<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/book.parallel.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'ru',
  ),
  'this' => 
  array (
    0 => 'class.parallel-future.php',
    1 => 'parallel\\Future',
  ),
  'up' => 
  array (
    0 => 'book.parallel.php',
    1 => 'parallel',
  ),
  'prev' => 
  array (
    0 => 'parallel-runtime.kill.php',
    1 => 'parallel\\Runtime::kill',
  ),
  'next' => 
  array (
    0 => 'parallel-future.cancel.php',
    1 => 'parallel\\Future::cancel',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'ru',
    'path' => 'reference/parallel/parallel.future.xml',
  ),
  'history' => 
  array (
  ),
  'extra_header_links' => 
  array (
    'rel' => 'alternate',
    'href' => '/manual/en/feeds/class.parallel-future.atom',
    'type' => 'application/atom+xml',
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="class.parallel-future" class="reference">

 <h1 class="title">Класс parallel\Future</h1>
 

 <div class="partintro"><p class="verinfo">(0.8.0)</p>

  <div class="section">
    <h2 class="title">Объекты Future</h2>
    <p class="para">
     Future представляет возвращаемое значение или неперехваченное исключение из задачи и предоставляет API для отмены.
    </p>
     <div class="example" id="">
      <p><strong>Пример #1 Пример, показывающий Future как возвращаемое значение</strong></p>
      <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />$runtime </span><span style="color: #007700">= new </span><span style="color: #0000BB">\parallel\Runtime</span><span style="color: #007700">;<br /></span><span style="color: #0000BB">$future  </span><span style="color: #007700">= </span><span style="color: #0000BB">$runtime</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">run</span><span style="color: #007700">(function(){<br />    return </span><span style="color: #DD0000">"Мир"</span><span style="color: #007700">;<br />});<br /></span><span style="color: #0000BB">printf</span><span style="color: #007700">(</span><span style="color: #DD0000">"Привет, %s\n"</span><span style="color: #007700">, </span><span style="color: #0000BB">$future</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">value</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
      </div>

      
<div class="example-contents"><p>
 Вывод приведённого примера будет похож на:
</p></div>

      <div class="example-contents screen">
<div class="cdata"><pre>
Привет, Мир
</pre></div>
      </div>
     </div>
    <p class="para">
     Поведение Future также позволяет использовать его в качестве простой точки синхронизации,
     даже если задача не возвращает значение явно.
    </p>
     <div class="example" id="">
      <p><strong>Пример #2 Пример, показывающий Future как точку синхронизации</strong></p>
      <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />$runtime </span><span style="color: #007700">= new </span><span style="color: #0000BB">\parallel\Runtime</span><span style="color: #007700">;<br /></span><span style="color: #0000BB">$future  </span><span style="color: #007700">= </span><span style="color: #0000BB">$runtime</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">run</span><span style="color: #007700">(function(){<br />    echo </span><span style="color: #DD0000">"в дочернем потоке "</span><span style="color: #007700">;<br />    for (</span><span style="color: #0000BB">$i </span><span style="color: #007700">= </span><span style="color: #0000BB">0</span><span style="color: #007700">; </span><span style="color: #0000BB">$i </span><span style="color: #007700">&lt; </span><span style="color: #0000BB">500</span><span style="color: #007700">; </span><span style="color: #0000BB">$i</span><span style="color: #007700">++) {<br />        if (</span><span style="color: #0000BB">$i </span><span style="color: #007700">% </span><span style="color: #0000BB">10 </span><span style="color: #007700">== </span><span style="color: #0000BB">0</span><span style="color: #007700">) {<br />            echo </span><span style="color: #DD0000">"."</span><span style="color: #007700">;<br />        }<br />    }<br />    echo </span><span style="color: #DD0000">" выход из дочернего потока"</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">$future</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">value</span><span style="color: #007700">();<br />echo </span><span style="color: #DD0000">"\nродительский поток продолжает работать\n"</span><span style="color: #007700">;<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
      </div>

      
<div class="example-contents"><p>
 Вывод приведённого примера будет похож на:
</p></div>

      <div class="example-contents screen">
<div class="cdata"><pre>
в дочернем потоке .................................................. выход из дочернего потока
родительский поток продолжает работать
</pre></div>
      </div>
     </div>
  </div>

  <div class="section" id="parallel-future.synopsis">
   <h2 class="title">Обзор классов</h2>


   <div class="classsynopsis">
    <span class="ooclass"><strong class="classname"></strong></span>


    <div class="classsynopsisinfo">
     <span class="ooclass">
      <span class="modifier">final</span>
      <span class="modifier">class</span> <strong class="classname">parallel\Future</strong>
     </span>
     {</div>


    <div class="classsynopsisinfo classsynopsisinfo_comment">/* Разрешение */</div>
    <div class="methodsynopsis dc-description">
   <span class="modifier">public</span> <span class="methodname"><a href="parallel-future.value.php" class="methodname">value</a></span>(): <span class="type"><a href="language.types.mixed.php" class="type mixed">mixed</a></span></div>


    <div class="classsynopsisinfo classsynopsisinfo_comment">/* Состояние */</div>
    <div class="methodsynopsis dc-description"><span class="modifier">public</span> <span class="methodname"><a href="parallel-future.cancelled.php" class="methodname">cancelled</a></span>(): <span class="type"><a href="language.types.boolean.php" class="type bool">bool</a></span></div>
<div class="methodsynopsis dc-description"><span class="modifier">public</span> <span class="methodname"><a href="parallel-future.done.php" class="methodname">done</a></span>(): <span class="type"><a href="language.types.boolean.php" class="type bool">bool</a></span></div>


    <div class="classsynopsisinfo classsynopsisinfo_comment">/* Отмена */</div>
    <div class="methodsynopsis dc-description"><span class="modifier">public</span> <span class="methodname"><a href="parallel-future.cancel.php" class="methodname">cancel</a></span>(): <span class="type"><a href="language.types.boolean.php" class="type bool">bool</a></span></div>


   }</div>


  </div>

 </div>

 





























<h2>Содержание</h2><ul class="chunklist chunklist_reference"><li><a href="parallel-future.cancel.php">parallel\Future::cancel</a> — Прекращение</li><li><a href="parallel-future.cancelled.php">parallel\Future::cancelled</a> — Определение состояния</li><li><a href="parallel-future.done.php">parallel\Future::done</a> — Определение состояния</li><li><a href="parallel-future.value.php">parallel\Future::value</a> — Разрешение</li></ul>
</div>
<?php manual_footer($setup); ?>